* MW: implement ML toplevel spans in official Isabelle, e.g.
  with separator \<^medskip> and some tool support for automated
  update (in "isabelle update" and/or PIDE);

* MW?: rename *.sml to *.ML, potentially with tool support;

* MW: clarify/eliminate Isabelle/Scala add-ons (presently unused)

    diff -r /home/makarius/isabelle/repos-Isabelle2021/src/Pure/build-jars ./src/Pure/build-jars
    11a12
    >   src/Tools/isac/BridgeJEdit/isac.scala

    diff -r /home/makarius/isabelle/repos-Isabelle2021/src/Pure/Tools/scala_project.scala ./src/Pure/Tools/scala_project.scala
    76a77
    >       "src/Tools/isac/etc" -> Path.explode("isabelle.isac"),

* MW: Skip_Proof.make_thm: theory -> term -> thm        ? could now change signature to
                         : Proof.context -> term -> thm
* MW: Make $ISABELLE_ISAC_TEST work without sessions (please synchronise with WN)
* MW: ? implement a template, inserted in a proof in the line of metis;
      hints are given in src/../BridgeJEdit/template.sml
      and in            test/../BridgeJEdit/template.sml

***** some items for discussion

* Clarify symmetric rule: Thm.apply_attribute Calculation.symmetric thm context (!?);
    ??

* "fun pr_ord" is not required if used with @{make_string}, @{print}, @{print tracing};
    takes only static arguments ----------------^^^^^^^^^^^^^^, not value of "hd_ord (f, g)"
    ? are there better approximations to old output of (*1*) than with (*2*)
    (*1*)val _ = tracing ("hd_ord (f, g)      = " ^ ((pr_ord o hd_ord) (f, g)) );
    (*2*)val _ = @{print tracing}{a = "hd_ord (f, g)      = ", z = hd_ord (f, g)}(**)


***** for the few items below WN asks MW for help

* strange ?ML?-error WN230404 (= pointer to respective test): Test_Isac.thy runs without errors except 3 files
    "Knowledge/eqsystem-1.sml"
    "Knowledge/eqsystem-2.sml"
    "Knowledge/eqsystem-3.sml"
  This error is strange, since these 3 fiels use the same src as others; the error remains although the
  constructors of both functions, Pre_Conditionss.mk_env and I_Model.feedback_OLD_to_TEST, 
  have been made equal (Model_Def.Cor_TEST, etc).

* postpone: ?How accomplish two user-requirements by Outer_Syntax.command \<^command_keyword>\<open>Example\<close>
   (1) start a Calculation with a CAS_Cmd
   (2) start an Example from scratch, i.e. with (Formalize.empty, References.empty)
   Proposals for a solution are in test/../Test_VSCode_Example.thy
   in subsubsection ‹Start Example with a CAS_Cmd›


***** priority of WN items is top down, most urgent/simple on top

* WN: ---broken elementwise input to lists---
* WN: undetected ERROR in autoCalculate --- due to Post_Conds.check? (_OLD .. dispels ?)
* WN: "review (descriptor, ts)"; ts : term list, because this supports element-wise input of lists.
  ts = [_] is determined by <Model_Pattern.is_list_descr descriptor>.
  Thus, as long (descriptor, ts) is together, ts never contains <Const ("List.list.Cons", _)> --
  this holds for specify-phase internally, but not to the outside (presentation to user, transfer to solve-phase).
  TODO: shift this as comment to structure Model_Def, type o_model_single + referenced by datatype i_model_feedback.
  TODO: o_model, i_model etc
* WN: type descriptor is defind 5 times !!!
* WN: introduction of I_Model.T_TEST is a huge step, which is partitioned into smaller steps, starting with
   changeset cb44eefd3c7b "repare 1 PIDE turn 11: .." and continued with "repare 1..n".
   After changeset 94242a19b04c "prepare 4: narrow I_Model.T -- _TEST" it seems no more possible to make the test(s)
   in test/../Test_Theory.thy run without braking too many tests. Thus
      minimal code in src/* is changed and marked by (*T_TESTold*)xxx(*T_TEST* )xxx( *T_TESTnew*)
      while the outcommenting shown is used for commits (where Test_Isac_Shorts runs without errors,
      but Test_Theory.thy doen't work).
* WN: ad CS "remove sep_variants_envs":
      test/../i-model.sml (*/----- reactivate with CS "remove sep_variants_envs"-----\* )
* WN: DEL get_simplifier: is only used in test/*
* WN: test/../pre-conditions.sml: there seems something wrong with env_subst-?-env_eval in check_TEST
      thus we introduced check_TEST', compare --- Minisubplb/200-start-method-NEXT_STEP.sml ---
* WN: replace take in LibraryC with take from Library
* WN: Syntax.read_term @{context} --> Syntax.read_term\<^context> , see I_Model "UnIqE_tErM"
* WN: renaming in References
* WN: shift code from libraryC.sml to designated destination (ThyC, etc)
* WN: rename type Rule.rule -> Rule.T
* WN: improve naming in refine.sml, m-match.sml
* WN: review ?code ERROR? in Rewrite.eval_true, see WN230329

* WN: consider redesign of Pre_Conds.mk_envs <-?- Pre_Conds.environment together with Model_Pattern.split_descriptor
      which could eliminate isalist2list and make handling of lists more convenient, see --- build Pre_Conds.check_TEST
      Pre_Conds.environment is called seriously only once, "check (Tactic.Apply_Method" for preconds
      !relate to instantiation of programs arguments!
* WN: correct design flaw in fun eval_*, see aa8760e4d987
* WN: unify get_ctxt in Solve_Step, Ctree (*DEPRECATED*)
* WN: review Prog_Tac:
      (*+isa==isa2*)@{term "Substitution []"};               (*Free ("Subproblem",.. ALSO Subproblem, ?!*)
      (*+isa==isa2*)@{term "Rewrite_Set ''norm_Rational''"}; (*Const ("Prog_Tac.Rewrite_Set",..*)

* WN: Step_Specify.initialise: remove hdl in return-value, replace Step_Specify.initialise' xxx'
      ? which uses initialise !?
* WN: ? unify "no_met" with "empty_meth_id" from References.empty ?

* WN: proper ML antiquotations for "Tactical.Try" etc. --- be careful about unclear situations,
  e.g. "Tactical.Try" vs. "Lucas_Interpreter.Try";

* WN: ? Rational.Cancel_p; extend use of \<^theory> to \<^theory_context>

* WN: Check/clarify Context.theory_name vs. Context.theory_long_name.
    Context.theory_name seems to suffice after elimination of sessions.

* WN: more direct logical foundations wrt. Isabelle/HOL, eliminate many axiomatizations
    - quite often "axiomatization ..." can be turned into "lemma ... by auto"
      without further ado;
    - sometimes this requires to use more specific types / type classes;
    - sometimes this requires to use proper definitional mechanisms (e.g. 'primrec', 'fun');
    - a few "hard" cases will remain, to be reconsidered eventually (e.g. differentiation);

* WN: rename Pos.* -- Pos.ints, Pos.spec, Pos.empty, Pos.ints_empty

* WN: redesign transition from Specification to Solution: how relate 
    - Formalise.model with variants (e.g. VSCode_Example)
      reconsider separation of variants F_I, F_II, see MAWEN paper
    - !?! I_Model of MethodC          (fairly free sequence, dependent on Formalise.model)
    - !?! formal arguments of program (fixed sequence)

* WN: avoid too many uses of "structure Data = Theory_Data", instead use approx. 1 data slot
  per ML module, with type T = ... record or tuple (e.g. see @{apply} ML antiquotation)

* WN: rename *.sml to *.ML, potentially with tool support by MW;
* WN: rename src/Tools/isac/ to main/ (or something else);
        rename  src/Tools/isac/BridgeJEdit and test/Tools/isac/BridgeJEdit to */Tools/isac/BridgePIDE
