(* theory collecting all knowledge 
   (predicates 'is_rootEq_in', 'is_sqrt_in', 'is_ratEq_in')
   for PolynomialEquations.
   alternative dependencies see @{theory "Isac_Knowledge"}
   created by: rlang 
         date: 02.07
   changed by: rlang
   last change by: rlang
             date: 03.06.03
   (c) by Richard Lang, 2003
*)

theory PolyEq imports LinEq RootRatEq begin 

(*-------------------- rules -------------------------------------------------*)
(* type real enforced by op " \<up> " *)
axiomatization where
  cancel_leading_coeff1: "Not (c =!= 0) ==> (a + b*bdv + c*bdv \<up> 2 = 0) = 
			                   (a/c + b/c*bdv + bdv \<up> 2 = 0)" and
  cancel_leading_coeff2: "Not (c =!= 0) ==> (a - b*bdv + c*bdv \<up> 2 = 0) = 
			                   (a/c - b/c*bdv + bdv \<up> 2 = 0)" and
  cancel_leading_coeff3: "Not (c =!= 0) ==> (a + b*bdv - c*bdv \<up> 2 = 0) = 
			                   (a/c + b/c*bdv - bdv \<up> 2 = 0)" and

  cancel_leading_coeff4: "Not (c =!= 0) ==> (a +   bdv + c*bdv \<up> 2 = 0) = 
			                   (a/c + 1/c*bdv + bdv \<up> 2 = 0)" and
  cancel_leading_coeff5: "Not (c =!= 0) ==> (a -   bdv + c*bdv \<up> 2 = 0) = 
			                   (a/c - 1/c*bdv + bdv \<up> 2 = 0)" and
  cancel_leading_coeff6: "Not (c =!= 0) ==> (a +   bdv - c*bdv \<up> 2 = 0) = 
			                   (a/c + 1/c*bdv - bdv \<up> 2 = 0)" and

  cancel_leading_coeff7: "Not (c =!= 0) ==> (    b*bdv + c*bdv \<up> 2 = 0) = 
			                   (    b/c*bdv + bdv \<up> 2 = 0)" and
  cancel_leading_coeff8: "Not (c =!= 0) ==> (    b*bdv - c*bdv \<up> 2 = 0) = 
			                   (    b/c*bdv - bdv \<up> 2 = 0)" and

  cancel_leading_coeff9: "Not (c =!= 0) ==> (      bdv + c*bdv \<up> 2 = 0) = 
			                   (      1/c*bdv + bdv \<up> 2 = 0)" and
  cancel_leading_coeff10:"Not (c =!= 0) ==> (      bdv - c*bdv \<up> 2 = 0) = 
			                   (      1/c*bdv - bdv \<up> 2 = 0)" and

  cancel_leading_coeff11:"Not (c =!= 0) ==> (a +      b*bdv \<up> 2 = 0) = 
			                   (a/b +      bdv \<up> 2 = 0)" and
  cancel_leading_coeff12:"Not (c =!= 0) ==> (a -      b*bdv \<up> 2 = 0) = 
			                   (a/b -      bdv \<up> 2 = 0)" and
  cancel_leading_coeff13:"Not (c =!= 0) ==> (         b*bdv \<up> 2 = 0) = 
			                   (           bdv \<up> 2 = 0/b)" and

  complete_square1:      "(q + p*bdv + bdv \<up> 2 = 0) = 
		         (q + (p/2 + bdv) \<up> 2 = (p/2) \<up> 2)" and
  complete_square2:      "(    p*bdv + bdv \<up> 2 = 0) = 
		         (    (p/2 + bdv) \<up> 2 = (p/2) \<up> 2)" and
  complete_square3:      "(      bdv + bdv \<up> 2 = 0) = 
		         (    (1/2 + bdv) \<up> 2 = (1/2) \<up> 2)" and
		        
  complete_square4:      "(q - p*bdv + bdv \<up> 2 = 0) = 
		         (q + (p/2 - bdv) \<up> 2 = (p/2) \<up> 2)" and
  complete_square5:      "(q + p*bdv - bdv \<up> 2 = 0) = 
		         (q + (p/2 - bdv) \<up> 2 = (p/2) \<up> 2)" and

  square_explicit1:      "(a + b \<up> 2 = c) = ( b \<up> 2 = c - a)" and
  square_explicit2:      "(a - b \<up> 2 = c) = (-(b \<up> 2) = c - a)" and

  (*bdv_explicit* required type constrain to real in --- (-8 - 2*x + x \<up> 2 = 0),  by rewriting ---*)
  bdv_explicit1:         "(a + bdv = b) = (bdv = - a + (b::real))" and
  bdv_explicit2:         "(a - bdv = b) = ((-1)*bdv = - a + (b::real))" and
  bdv_explicit3:         "((-1)*bdv = b) = (bdv = (-1)*(b::real))" and

  plus_leq:              "(0 <= a + b) = ((-1)*b <= a)"(*Isa?*) and
  minus_leq:             "(0 <= a - b) = (     b <= a)"(*Isa?*) and

(*-- normalise --*)
  (*WN0509 compare LinEq.all_left "[|Not(b=!=0)|] ==> (a=b) = (a+(-1)*b=0)"*)
  all_left:              "[|Not(b=!=0)|] ==> (a = b) = (a - b = 0)" and
  makex1_x:              "a\<up>1  = a"   and
  real_assoc_1:          "a+(b+c) = a+b+c" and
  real_assoc_2:          "a*(b*c) = a*b*c" and

(* ---- degree 0 ----*)
  d0_true:               "(0=0) = True" and
  d0_false:              "[|Not(bdv occurs_in a);Not(a=0)|] ==> (a=0) = False" and
(* ---- degree 1 ----*)
  d1_isolate_add1:
   "[|Not(bdv occurs_in a)|] ==> (a + b*bdv = 0) = (b*bdv = (-1)*a)" and
  d1_isolate_add2:
   "[|Not(bdv occurs_in a)|] ==> (a +   bdv = 0) = (  bdv = (-1)*a)" and
  d1_isolate_div:
   "[|Not(b=0);Not(bdv occurs_in c)|] ==> (b*bdv = c) = (bdv = c/b)" and
(* ---- degree 2 ----*)
  d2_isolate_add1:
   "[|Not(bdv occurs_in a)|] ==> (a + b*bdv \<up> 2=0) = (b*bdv \<up> 2= (-1)*a)" and
  d2_isolate_add2:
   "[|Not(bdv occurs_in a)|] ==> (a +   bdv \<up> 2=0) = (  bdv \<up> 2= (-1)*a)" and
  d2_isolate_div:
   "[|Not(b=0);Not(bdv occurs_in c)|] ==> (b*bdv \<up> 2=c) = (bdv \<up> 2=c/b)" and
  
  d2_prescind1:          "(a*bdv + b*bdv \<up> 2 = 0) = (bdv*(a +b*bdv)=0)" and
  d2_prescind2:          "(a*bdv +   bdv \<up> 2 = 0) = (bdv*(a +  bdv)=0)" and
  d2_prescind3:          "(  bdv + b*bdv \<up> 2 = 0) = (bdv*(1+b*bdv)=0)" and
  d2_prescind4:          "(  bdv +   bdv \<up> 2 = 0) = (bdv*(1+  bdv)=0)" and
  (* eliminate degree 2 *)
  (* thm for neg arguments in sqroot have postfix _neg *)
  d2_sqrt_equation1:     "[|(0<=c);Not(bdv occurs_in c)|] ==> 
                         (bdv \<up> 2=c) = ((bdv=sqrt c) | (bdv=(-1)*sqrt c ))" and
 d2_sqrt_equation1_neg:
  "[|(c<0);Not(bdv occurs_in c)|] ==> (bdv \<up> 2=c) = False" and
  d2_sqrt_equation2:     "(bdv \<up> 2=0) = (bdv=0)" and
  d2_sqrt_equation3:     "(b*bdv \<up> 2=0) = (bdv=0)"
axiomatization where (*AK..if replaced by "and" we get errors:
  exception PTREE "nth _ []" raised 
  (line 783 of "/usr/local/isabisac/src/Tools/isac/Interpret/ctree.sml"):
    'fun nth _ []      = raise PTREE "nth _ []"'
and
  exception Bind raised 
  (line 1097 of "/usr/local/isabisac/test/Tools/isac/Frontend/interface.sml"):
    'val (Form f, tac, asms) = pt_extract (pt, p);' *)
  (* WN120315 these 2 thms need "::real", because no " \<up> " constrains type as
     required in test --- rls d2_polyeq_bdv_only_simplify --- *)
  d2_reduce_equation1:   "(bdv*(a +b*bdv)=0) = ((bdv=0)|(a+b*bdv=(0::real)))" and
  d2_reduce_equation2:   "(bdv*(a +  bdv)=0) = ((bdv=0)|(a+  bdv=(0::real)))"

axiomatization where (*..if replaced by "and" we get errors:
  exception PTREE "nth _ []" raised 
  (line 783 of "/usr/local/isabisac/src/Tools/isac/Interpret/ctree.sml"):
    'fun nth _ []      = raise PTREE "nth _ []"'
and
  exception Bind raised 
  (line 1097 of "/usr/local/isabisac/test/Tools/isac/Frontend/interface.sml"):
    'val (Form f, tac, asms) = pt_extract (pt, p);' *)
  d2_pqformula1:         "[|0<=p \<up> 2 - 4*q|] ==> (q+p*bdv+   bdv \<up> 2=0) =
                           ((bdv= (-1)*(p/2) + sqrt(p \<up> 2 - 4*q)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p \<up> 2 - 4*q)/2))" and
  d2_pqformula1_neg:     "[|p \<up> 2 - 4*q<0|] ==> (q+p*bdv+   bdv \<up> 2=0) = False" and
  d2_pqformula2:         "[|0<=p \<up> 2 - 4*q|] ==> (q+p*bdv+1*bdv \<up> 2=0) = 
                           ((bdv= (-1)*(p/2) + sqrt(p \<up> 2 - 4*q)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p \<up> 2 - 4*q)/2))" and
  d2_pqformula2_neg:     "[|p \<up> 2 - 4*q<0|] ==> (q+p*bdv+1*bdv \<up> 2=0) = False" and
  d2_pqformula3:         "[|0<=1 - 4*q|] ==> (q+  bdv+   bdv \<up> 2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 4*q)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 4*q)/2))" and
  d2_pqformula3_neg:     "[|1 - 4*q<0|] ==> (q+  bdv+   bdv \<up> 2=0) = False" and
  d2_pqformula4:         "[|0<=1 - 4*q|] ==> (q+  bdv+1*bdv \<up> 2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 4*q)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 4*q)/2))" and
  d2_pqformula4_neg:     "[|1 - 4*q<0|] ==> (q+  bdv+1*bdv \<up> 2=0) = False" and
  d2_pqformula5:         "[|0<=p \<up> 2 - 0|] ==> (  p*bdv+   bdv \<up> 2=0) =
                           ((bdv= (-1)*(p/2) + sqrt(p \<up> 2 - 0)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p \<up> 2 - 0)/2))" and
 (* d2_pqformula5_neg not need p^2 never less zero in R *)
  d2_pqformula6:         "                     (  p*bdv+1*bdv \<up> 2=0) = 
                           ((bdv= (-1)*(p/2) + sqrt(p \<up> 2 - 0)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p \<up> 2 - 0)/2))" and
  (* d2_pqformula6_neg not need p^2 never less zero in R *)
   d2_pqformula7:        "                 (    bdv+   bdv \<up> 2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 0)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 0)/2))" and
  (* d2_pqformula7_neg not need, because 1<0 ==> False*)
  d2_pqformula8:        "                 (    bdv+1*bdv \<up> 2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 0)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 0)/2))" and
  (* d2_pqformula8_neg not need, because 1<0 ==> False*)
  d2_pqformula9:        "[|Not(bdv occurs_in q); 0<= (-1)*4*q|] ==> 
                           (q+    1*bdv \<up> 2=0) = ((bdv= 0 + sqrt(0 - 4*q)/2) 
                                                | (bdv= 0 - sqrt(0 - 4*q)/2))" and
  d2_pqformula9_neg:
   "[|Not(bdv occurs_in q); (-1)*4*q<0|] ==> (q+    1*bdv \<up> 2=0) = False" and
  d2_pqformula10:
   "[|Not(bdv occurs_in q); 0<= (-1)*4*q|] ==> (q+     bdv \<up> 2=0) = 
           ((bdv= 0 + sqrt(0 - 4*q)/2) 
          | (bdv= 0 - sqrt(0 - 4*q)/2))" and
  d2_pqformula10_neg:
   "[|Not(bdv occurs_in q); (-1)*4*q<0|] ==> (q+     bdv \<up> 2=0) = False" and
  d2_abcformula1:
   "[|0<=b \<up> 2 - 4*a*c|] ==> (c + b*bdv+a*bdv \<up> 2=0) =
           ((bdv=( -b + sqrt(b \<up> 2 - 4*a*c))/(2*a)) 
          | (bdv=( -b - sqrt(b \<up> 2 - 4*a*c))/(2*a)))" and
  d2_abcformula1_neg:
   "[|b \<up> 2 - 4*a*c<0|] ==> (c + b*bdv+a*bdv \<up> 2=0) = False" and
  d2_abcformula2:
   "[|0<=1 - 4*a*c|]     ==> (c+    bdv+a*bdv \<up> 2=0) = 
           ((bdv=( -1 + sqrt(1 - 4*a*c))/(2*a)) 
          | (bdv=( -1 - sqrt(1 - 4*a*c))/(2*a)))" and
  d2_abcformula2_neg:
   "[|1 - 4*a*c<0|]     ==> (c+    bdv+a*bdv \<up> 2=0) = False" and
  d2_abcformula3:
   "[|0<=b \<up> 2 - 4*1*c|] ==> (c + b*bdv+  bdv \<up> 2=0) =
           ((bdv=( -b + sqrt(b \<up> 2 - 4*1*c))/(2*1)) 
          | (bdv=( -b - sqrt(b \<up> 2 - 4*1*c))/(2*1)))" and
  d2_abcformula3_neg:
   "[|b \<up> 2 - 4*1*c<0|] ==> (c + b*bdv+  bdv \<up> 2=0) = False" and
  d2_abcformula4:
   "[|0<=1 - 4*1*c|] ==> (c +   bdv+  bdv \<up> 2=0) =
           ((bdv=( -1 + sqrt(1 - 4*1*c))/(2*1)) 
          | (bdv=( -1 - sqrt(1 - 4*1*c))/(2*1)))" and
  d2_abcformula4_neg:
   "[|1 - 4*1*c<0|] ==> (c +   bdv+  bdv \<up> 2=0) = False" and
  d2_abcformula5:
   "[|Not(bdv occurs_in c); 0<=0 - 4*a*c|] ==> (c +  a*bdv \<up> 2=0) =
           ((bdv=( 0 + sqrt(0 - 4*a*c))/(2*a)) 
          | (bdv=( 0 - sqrt(0 - 4*a*c))/(2*a)))" and
  d2_abcformula5_neg:
   "[|Not(bdv occurs_in c); 0 - 4*a*c<0|] ==> (c +  a*bdv \<up> 2=0) = False" and
  d2_abcformula6:
   "[|Not(bdv occurs_in c); 0<=0 - 4*1*c|]     ==> (c+    bdv \<up> 2=0) = 
           ((bdv=( 0 + sqrt(0 - 4*1*c))/(2*1)) 
          | (bdv=( 0 - sqrt(0 - 4*1*c))/(2*1)))" and
  d2_abcformula6_neg:
   "[|Not(bdv occurs_in c); 0 - 4*1*c<0|]     ==> (c+    bdv \<up> 2=0) = False" and
  d2_abcformula7:
   "                         (    b*bdv+a*bdv \<up> 2=0) = 
           ((bdv=( -b + sqrt(b \<up> 2 - 0))/(2*a)) 
          | (bdv=( -b - sqrt(b \<up> 2 - 0))/(2*a)))" and
  (* d2_abcformula7_neg not need b^2 never less zero in R *)
  d2_abcformula8:
   "                     (    b*bdv+  bdv \<up> 2=0) =
           ((bdv=( -b + sqrt(b \<up> 2 - 0))/(2*1)) 
          | (bdv=( -b - sqrt(b \<up> 2 - 0))/(2*1)))" and
  (* d2_abcformula8_neg not need b^2 never less zero in R *)
  d2_abcformula9:
   "                     (      bdv+a*bdv \<up> 2=0) = 
           ((bdv=( -1 + sqrt(1 - 0))/(2*a)) 
          | (bdv=( -1 - sqrt(1 - 0))/(2*a)))" and
  (* d2_abcformula9_neg not need, because 1<0 ==> False*)
  d2_abcformula10:
   "                 (      bdv+  bdv \<up> 2=0) =
           ((bdv=( -1 + sqrt(1 - 0))/(2*1)) 
          | (bdv=( -1 - sqrt(1 - 0))/(2*1)))" and
  (* d2_abcformula10_neg not need, because 1<0 ==> False*)


(* ---- degree 3 ----*)
  d3_reduce_equation1:
  "(a*bdv + b*bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (a + b*bdv + c*bdv \<up> 2=0))" and
  d3_reduce_equation2:
  "(  bdv + b*bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (1 + b*bdv + c*bdv \<up> 2=0))" and
  d3_reduce_equation3:
  "(a*bdv +   bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (a +   bdv + c*bdv \<up> 2=0))" and
  d3_reduce_equation4:
  "(  bdv +   bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (1 +   bdv + c*bdv \<up> 2=0))" and
  d3_reduce_equation5:
  "(a*bdv + b*bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (a + b*bdv +   bdv \<up> 2=0))" and
  d3_reduce_equation6:
  "(  bdv + b*bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (1 + b*bdv +   bdv \<up> 2=0))" and
  d3_reduce_equation7:
  "(a*bdv +   bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (1 +   bdv +   bdv \<up> 2=0))" and
  d3_reduce_equation8:
  "(  bdv +   bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (1 +   bdv +   bdv \<up> 2=0))" and
  d3_reduce_equation9:
  "(a*bdv             + c*bdv \<up> 3=0) = (bdv=0 | (a         + c*bdv \<up> 2=0))" and
  d3_reduce_equation10:
  "(  bdv             + c*bdv \<up> 3=0) = (bdv=0 | (1         + c*bdv \<up> 2=0))" and
  d3_reduce_equation11:
  "(a*bdv             +   bdv \<up> 3=0) = (bdv=0 | (a         +   bdv \<up> 2=0))" and
  d3_reduce_equation12:
  "(  bdv             +   bdv \<up> 3=0) = (bdv=0 | (1         +   bdv \<up> 2=0))" and
  d3_reduce_equation13:
  "(        b*bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (    b*bdv + c*bdv \<up> 2=0))" and
  d3_reduce_equation14:
  "(          bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (      bdv + c*bdv \<up> 2=0))" and
  d3_reduce_equation15:
  "(        b*bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (    b*bdv +   bdv \<up> 2=0))" and
  d3_reduce_equation16:
  "(          bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (      bdv +   bdv \<up> 2=0))" and
  d3_isolate_add1:
  "[|Not(bdv occurs_in a)|] ==> (a + b*bdv \<up> 3=0) = (b*bdv \<up> 3= (-1)*a)" and
  d3_isolate_add2:
  "[|Not(bdv occurs_in a)|] ==> (a +   bdv \<up> 3=0) = (  bdv \<up> 3= (-1)*a)" and
  d3_isolate_div:
   "[|Not(b=0);Not(bdv occurs_in a)|] ==> (b*bdv \<up> 3=c) = (bdv \<up> 3=c/b)" and
  d3_root_equation2:
  "(bdv \<up> 3=0) = (bdv=0)" and
  d3_root_equation1:
  "(bdv \<up> 3=c) = (bdv = nroot 3 c)" and

(* ---- degree 4 ----*)
 (* RL03.FIXME es wir nicht getestet ob u>0 *)
 d4_sub_u1:
 "(c+b*bdv \<up> 2+a*bdv \<up> 4=0) =
   ((a*u \<up> 2+b*u+c=0) & (bdv \<up> 2=u))" and

(* ---- 7.3.02 von Termorder ---- *)

  bdv_collect_1:      "l * bdv + m * bdv = (l + m) * bdv" and
  bdv_collect_2:      "bdv + m * bdv = (1 + m) * bdv" and
  bdv_collect_3:      "l * bdv + bdv = (l + 1) * bdv" and

(*  bdv_collect_assoc0_1 "l * bdv + m * bdv + k = (l + m) * bdv + k"
    bdv_collect_assoc0_2 "bdv + m * bdv + k = (1 + m) * bdv + k"
    bdv_collect_assoc0_3 "l * bdv + bdv + k = (l + 1) * bdv + k"
*)
  bdv_collect_assoc1_1: "l * bdv + (m * bdv + k) = (l + m) * bdv + k" and
  bdv_collect_assoc1_2: "bdv + (m * bdv + k) = (1 + m) * bdv + k" and
  bdv_collect_assoc1_3: "l * bdv + (bdv + k) = (l + 1) * bdv + k" and
                        
  bdv_collect_assoc2_1: "k + l * bdv + m * bdv = k + (l + m) * bdv" and
  bdv_collect_assoc2_2: "k + bdv + m * bdv = k + (1 + m) * bdv" and
  bdv_collect_assoc2_3: "k + l * bdv + bdv = k + (l + 1) * bdv" and


  bdv_n_collect_1:     "l * bdv \<up> n + m * bdv \<up> n = (l + m) * bdv \<up> n" and
  bdv_n_collect_2:     " bdv \<up> n + m * bdv \<up> n = (1 + m) * bdv \<up> n" and
  bdv_n_collect_3:     "l * bdv \<up> n + bdv \<up> n = (l + 1) * bdv \<up> n" (*order!*) and

  bdv_n_collect_assoc1_1: "l * bdv \<up> n + (m * bdv \<up> n + k) = (l + m) * bdv \<up> n + k" and
  bdv_n_collect_assoc1_2: "bdv \<up> n + (m * bdv \<up> n + k) = (1 + m) * bdv \<up> n + k" and
  bdv_n_collect_assoc1_3: "l * bdv \<up> n + (bdv \<up> n + k) = (l + 1) * bdv \<up> n + k" and

  bdv_n_collect_assoc2_1: "k + l * bdv \<up> n + m * bdv \<up> n = k +(l + m) * bdv \<up> n" and
  bdv_n_collect_assoc2_2: "k + bdv \<up> n + m * bdv \<up> n = k + (1 + m) * bdv \<up> n" and
  bdv_n_collect_assoc2_3: "k + l * bdv \<up> n + bdv \<up> n = k + (l + 1) * bdv \<up> n" and

(*WN.14.3.03*)
  real_minus_div:         "- (a / b) = (-1 * a) / b" and
                          
  separate_bdv:           "(a * bdv) / b = (a / b) * (bdv::real)" and
  separate_bdv_n:         "(a * bdv \<up> n) / b = (a / b) * bdv \<up> n" and
  separate_1_bdv:         "bdv / b = (1 / b) * (bdv::real)" and
  separate_1_bdv_n:       "bdv \<up> n / b = (1 / b) * bdv \<up> n"

ML \<open>
val PolyEq_prls = (*3.10.02:just the following order due to subterm evaluation*)
  Rule_Set.append_rules "PolyEq_prls" Rule_Set.empty [
     \<^rule_eval>\<open>ident\<close> (Prog_Expr.eval_ident "#ident_"),
     \<^rule_eval>\<open>matches\<close> (Prog_Expr.eval_matches "#matches_"),
     \<^rule_eval>\<open>lhs\<close> (Prog_Expr.eval_lhs ""),
     \<^rule_eval>\<open>rhs\<close> (Prog_Expr.eval_rhs ""),
     \<^rule_eval>\<open>is_expanded_in\<close> (eval_is_expanded_in ""),
     \<^rule_eval>\<open>is_poly_in\<close> (eval_is_poly_in ""),
     \<^rule_eval>\<open>has_degree_in\<close> (eval_has_degree_in ""),    
     \<^rule_eval>\<open>is_polyrat_in\<close> (eval_is_polyrat_in ""),
     \<^rule_eval>\<open>HOL.eq\<close> (Prog_Expr.eval_equal "#equal_"),
     \<^rule_eval>\<open>is_rootTerm_in\<close> (eval_is_rootTerm_in ""),
     \<^rule_eval>\<open>is_ratequation_in\<close> (eval_is_ratequation_in ""),
     \<^rule_thm>\<open>not_true\<close>,
     \<^rule_thm>\<open>not_false\<close>,
     \<^rule_thm>\<open>and_true\<close>,
     \<^rule_thm>\<open>and_false\<close>,
     \<^rule_thm>\<open>or_true\<close>,
     \<^rule_thm>\<open>or_false\<close>];

val PolyEq_erls = 
  Rule_Set.merge "PolyEq_erls" LinEq_erls
    (Rule_Set.append_rules "ops_preds" calculate_Rational [
     \<^rule_eval>\<open>HOL.eq\<close> (Prog_Expr.eval_equal "#equal_"),
		 \<^rule_thm>\<open>plus_leq\<close>,
		 \<^rule_thm>\<open>minus_leq\<close>,
		 \<^rule_thm>\<open>rat_leq1\<close>,
		 \<^rule_thm>\<open>rat_leq2\<close>,
		 \<^rule_thm>\<open>rat_leq3\<close>]);

val PolyEq_crls = 
    Rule_Set.merge "PolyEq_crls" LinEq_crls
    (Rule_Set.append_rules "ops_preds" calculate_Rational [
     \<^rule_eval>\<open>HOL.eq\<close> (Prog_Expr.eval_equal "#equal_"),
		 \<^rule_thm>\<open>plus_leq\<close>,
		 \<^rule_thm>\<open>minus_leq\<close>,
		 \<^rule_thm>\<open>rat_leq1\<close>,
		 \<^rule_thm>\<open>rat_leq2\<close>,
		 \<^rule_thm>\<open>rat_leq3\<close>
		 ]);

val cancel_leading_coeff = prep_rls'(
  Rule_Def.Repeat {id = "cancel_leading_coeff", preconds = [], 
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty),
    asm_rls = PolyEq_erls, prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>cancel_leading_coeff1\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff2\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff3\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff4\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff5\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff6\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff7\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff8\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff9\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff10\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff11\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff12\<close>,
      \<^rule_thm>\<open>cancel_leading_coeff13\<close> ],
    program = Rule.Empty_Prog});

val prep_rls' = Auto_Prog.prep_rls @{theory};
\<close>
ML\<open>
val complete_square = prep_rls'(
  Rule_Def.Repeat {id = "complete_square", preconds = [], 
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty),
    asm_rls = PolyEq_erls, prog_rls = Rule_Set.Empty, calc = [],  errpatts = [],
    rules = [
      \<^rule_thm>\<open>complete_square1\<close>,
      \<^rule_thm>\<open>complete_square2\<close>,
      \<^rule_thm>\<open>complete_square3\<close>,
      \<^rule_thm>\<open>complete_square4\<close>,
      \<^rule_thm>\<open>complete_square5\<close>],
    program = Rule.Empty_Prog});

val polyeq_simplify = prep_rls'(
  Rule_Def.Repeat {id = "polyeq_simplify", preconds = [], 
    rew_ord = ("termlessI",termlessI), 
    asm_rls = PolyEq_erls, 
    prog_rls = Rule_Set.Empty, 
    calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>real_assoc_1\<close>,
  		\<^rule_thm>\<open>real_assoc_2\<close>,
  		\<^rule_thm>\<open>real_diff_minus\<close>,
  		\<^rule_thm>\<open>real_unari_minus\<close>,
  		\<^rule_thm>\<open>realpow_multI\<close>,
  		\<^rule_eval>\<open>plus\<close> (**)(Calc_Binop.numeric "#add_"),
  		\<^rule_eval>\<open>minus\<close> (**)(Calc_Binop.numeric "#sub_"),
  		\<^rule_eval>\<open>times\<close> (**)(Calc_Binop.numeric "#mult_"),
  		\<^rule_eval>\<open>divide\<close> (Prog_Expr.eval_cancel "#divide_e"),
  		\<^rule_eval>\<open>sqrt\<close> (eval_sqrt "#sqrt_"),
  		\<^rule_eval>\<open>realpow\<close> (**)(Calc_Binop.numeric "#power_"),
       Rule.Rls_ reduce_012],
    program = Rule.Empty_Prog});
\<close>
rule_set_knowledge
  cancel_leading_coeff = cancel_leading_coeff and
  complete_square = complete_square and
  PolyEq_erls = PolyEq_erls and
  polyeq_simplify = polyeq_simplify
ML\<open>

(* the subsequent rule-sets are caused by the lack of rewriting at the time of implementation *)
(* -- d0 -- *)
(*isolate the bound variable in an d0 equation; 'bdv' is a meta-constant*)
val d0_polyeq_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d0_polyeq_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty),
    asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, 
    calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d0_true\<close>,
      \<^rule_thm>\<open>d0_false\<close>],
    program = Rule.Empty_Prog});

(* -- d1 -- *)
(*isolate the bound variable in an d1 equation; 'bdv' is a meta-constant*)
val d1_polyeq_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d1_polyeq_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty),
    asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, 
    calc = [], errpatts = [],
    rules = [
  		\<^rule_thm>\<open>d1_isolate_add1\<close>, (* a+bx=0 -> bx=-a *)
  		\<^rule_thm>\<open>d1_isolate_add2\<close>, (* a+ x=0 ->  x=-a *)
  		\<^rule_thm>\<open>d1_isolate_div\<close>   (*   bx=c -> x=c/b *)],
    program = Rule.Empty_Prog});
\<close>

subsection \<open>degree 2\<close>
ML\<open>
(* isolate the bound variable in an d2 equation with bdv only;
  "bdv" is a meta-constant substituted for the "x" below by isac's rewriter. *)
val d2_polyeq_bdv_only_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d2_polyeq_bdv_only_simplify", preconds = [], rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty),
    asm_rls = PolyEq_erls, prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
       \<^rule_thm>\<open>d2_prescind1\<close>, (*   ax+bx^2=0 -> x(a+bx)=0 *)
       \<^rule_thm>\<open>d2_prescind2\<close>, (*   ax+ x^2=0 -> x(a+ x)=0 *)
       \<^rule_thm>\<open>d2_prescind3\<close>, (*    x+bx^2=0 -> x(1+bx)=0 *)
       \<^rule_thm>\<open>d2_prescind4\<close>, (*    x+ x^2=0 -> x(1+ x)=0 *)
       \<^rule_thm>\<open>d2_sqrt_equation1\<close>,    (* x^2=c   -> x=+-sqrt(c) *)
       \<^rule_thm>\<open>d2_sqrt_equation1_neg\<close>, (* [0<c] x^2=c  -> []*)
       \<^rule_thm>\<open>d2_sqrt_equation2\<close>,    (*  x^2=0 ->    x=0       *)
       \<^rule_thm>\<open>d2_reduce_equation1\<close>,(* x(a+bx)=0 -> x=0 |a+bx=0*)
       \<^rule_thm>\<open>d2_reduce_equation2\<close>,(* x(a+ x)=0 -> x=0 |a+ x=0*)
       \<^rule_thm>\<open>d2_isolate_div\<close>],           (* bx^2=c -> x^2=c/b      *)
    program = Rule.Empty_Prog});

(* isolate the bound variable in an d2 equation with sqrt only;
   'bdv' is a meta-constant*)
val d2_polyeq_sq_only_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d2_polyeq_sq_only_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty),
    asm_rls = PolyEq_erls, prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d2_isolate_add1\<close>,(* a+   bx^2=0 -> bx^2=(-1)a*)
  		\<^rule_thm>\<open>d2_isolate_add2\<close>,  (* a+    x^2=0 ->  x^2=(-1)a*)
  		\<^rule_thm>\<open>d2_sqrt_equation2\<close>,     (*  x^2=0 ->    x=0    *)
  		\<^rule_thm>\<open>d2_sqrt_equation1\<close>,      (* x^2=c   -> x=+-sqrt(c)*)
  		\<^rule_thm>\<open>d2_sqrt_equation1_neg\<close>,(* [c<0] x^2=c  -> x=[] *)
  		\<^rule_thm>\<open>d2_isolate_div\<close>],        (* bx^2=c -> x^2=c/b*)
    program = Rule.Empty_Prog});
\<close>
ML\<open>
(* isolate the bound variable in an d2 equation with pqFormula;
   'bdv' is a meta-constant*)
val d2_polyeq_pqFormula_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d2_polyeq_pqFormula_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty), asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d2_pqformula1\<close>, (* q+px+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula1_neg\<close>, (* q+px+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula2\<close>, (* q+px+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula2_neg\<close>, (* q+px+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula3\<close>, (* q+ x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula3_neg\<close>, (* q+ x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula4\<close>, (* q+ x+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula4_neg\<close>, (* q+ x+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula5\<close>, (*   qx+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula6\<close>, (*   qx+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula7\<close>, (*    x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula8\<close>, (*    x+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula9\<close>, (* q   +1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula9_neg\<close>, (* q   +1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula10\<close>, (* q   + x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula10_neg\<close>, (* q   + x^2=0 *)
  		\<^rule_thm>\<open>d2_sqrt_equation2\<close>, (*       x^2=0 *)
  		\<^rule_thm>\<open>d2_sqrt_equation3\<close>], (*      1x^2=0 *)
    program = Rule.Empty_Prog});

(* isolate the bound variable in an d2 equation with abcFormula;
   'bdv' is a meta-constant*)
val d2_polyeq_abcFormula_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d2_polyeq_abcFormula_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty), asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d2_abcformula1\<close>, (*c+bx+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula1_neg\<close>, (*c+bx+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula2\<close>, (*c+ x+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula2_neg\<close>, (*c+ x+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula3\<close>, (*c+bx+ x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula3_neg\<close>, (*c+bx+ x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula4\<close>, (*c+ x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula4_neg\<close>, (*c+ x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula5\<close>, (*c+   cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula5_neg\<close>, (*c+   cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula6\<close>, (*c+    x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula6_neg\<close>, (*c+    x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula7\<close>, (*  bx+ax^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula8\<close>, (*  bx+ x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula9\<close>, (*   x+ax^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula10\<close>, (*   x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_sqrt_equation2\<close>, (*      x^2=0 *)  
  		\<^rule_thm>\<open>d2_sqrt_equation3\<close>], (*     bx^2=0 *)  
    program = Rule.Empty_Prog});

(* isolate the bound variable in an d2 equation; 
   'bdv' is a meta-constant*)
val d2_polyeq_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d2_polyeq_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty), asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d2_pqformula1\<close>, (* p+qx+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula1_neg\<close>, (* p+qx+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula2\<close>, (* p+qx+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula2_neg\<close>, (* p+qx+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula3\<close>, (* p+ x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula3_neg\<close>, (* p+ x+ x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula4\<close>, (* p+ x+1x^2=0 *)
  		\<^rule_thm>\<open>d2_pqformula4_neg\<close>, (* p+ x+1x^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula1\<close>, (* c+bx+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula1_neg\<close>, (* c+bx+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula2\<close>, (* c+ x+cx^2=0 *)
  		\<^rule_thm>\<open>d2_abcformula2_neg\<close>, (* c+ x+cx^2=0 *)
  		\<^rule_thm>\<open>d2_prescind1\<close>, (*   ax+bx^2=0 -> x(a+bx)=0 *)
  		\<^rule_thm>\<open>d2_prescind2\<close>, (*   ax+ x^2=0 -> x(a+ x)=0 *)
  		\<^rule_thm>\<open>d2_prescind3\<close>, (*    x+bx^2=0 -> x(1+bx)=0 *)
  		\<^rule_thm>\<open>d2_prescind4\<close>, (*    x+ x^2=0 -> x(1+ x)=0 *)
  		\<^rule_thm>\<open>d2_isolate_add1\<close>, (* a+   bx^2=0 -> bx^2=(-1)a*)
  		\<^rule_thm>\<open>d2_isolate_add2\<close>, (* a+    x^2=0 ->  x^2=(-1)a*)
  		\<^rule_thm>\<open>d2_sqrt_equation1\<close>, (* x^2=c   -> x=+-sqrt(c)*)
  		\<^rule_thm>\<open>d2_sqrt_equation1_neg\<close>, (* [c<0] x^2=c   -> x=[]*)
  		\<^rule_thm>\<open>d2_sqrt_equation2\<close>, (*  x^2=0 ->    x=0    *)
  		\<^rule_thm>\<open>d2_reduce_equation1\<close>, (* x(a+bx)=0 -> x=0 | a+bx=0*)
  		\<^rule_thm>\<open>d2_reduce_equation2\<close>, (* x(a+ x)=0 -> x=0 | a+ x=0*)
  		\<^rule_thm>\<open>d2_isolate_div\<close>], (* bx^2=c -> x^2=c/b*)
    program = Rule.Empty_Prog});

(* -- d3 -- *)
(* isolate the bound variable in an d3 equation; 'bdv' is a meta-constant *)
val d3_polyeq_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d3_polyeq_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty), asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d3_reduce_equation1\<close>, (*a*bdv + b*bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (a + b*bdv + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation2\<close>, (*  bdv + b*bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (1 + b*bdv + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation3\<close>, (*a*bdv +   bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (a +   bdv + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation4\<close>, (*  bdv +   bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (1 +   bdv + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation5\<close>, (*a*bdv + b*bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (a + b*bdv +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation6\<close>, (*  bdv + b*bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (1 + b*bdv +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation7\<close>, (*a*bdv +   bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (1 +   bdv +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation8\<close>, (*  bdv +   bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (1 +   bdv +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation9\<close>, (*a*bdv             + c*bdv \<up> 3=0) = (bdv=0 | (a         + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation10\<close>, (*  bdv             + c*bdv \<up> 3=0) = (bdv=0 | (1         + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation11\<close>, (*a*bdv             +   bdv \<up> 3=0) = (bdv=0 | (a         +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation12\<close>, (*  bdv             +   bdv \<up> 3=0) = (bdv=0 | (1         +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation13\<close>, (*        b*bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (    b*bdv + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation14\<close>, (*          bdv \<up> 2 + c*bdv \<up> 3=0) = (bdv=0 | (      bdv + c*bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation15\<close>, (*        b*bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (    b*bdv +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_reduce_equation16\<close>, (*          bdv \<up> 2 +   bdv \<up> 3=0) = (bdv=0 | (      bdv +   bdv \<up> 2=0)*)
    	\<^rule_thm>\<open>d3_isolate_add1\<close>, (*[|Not(bdv occurs_in a)|] ==> (a + b*bdv \<up> 3=0) = (bdv=0 | (b*bdv \<up> 3=a)*)
    	\<^rule_thm>\<open>d3_isolate_add2\<close>, (*[|Not(bdv occurs_in a)|] ==> (a +   bdv \<up> 3=0) = (bdv=0 | (  bdv \<up> 3=a)*)
    	\<^rule_thm>\<open>d3_isolate_div\<close>, (*[|Not(b=0)|] ==> (b*bdv \<up> 3=c) = (bdv \<up> 3=c/b*)
      \<^rule_thm>\<open>d3_root_equation2\<close>, (*(bdv \<up> 3=0) = (bdv=0) *)
    	\<^rule_thm>\<open>d3_root_equation1\<close>], (*bdv \<up> 3=c) = (bdv = nroot 3 c*)
    program = Rule.Empty_Prog});

(* -- d4 -- *)
(*isolate the bound variable in an d4 equation; 'bdv' is a meta-constant*)
val d4_polyeq_simplify = prep_rls'(
  Rule_Def.Repeat {id = "d4_polyeq_simplify", preconds = [],
    rew_ord = ("Rewrite_Ord.id_empty",Rewrite_Ord.function_empty), asm_rls = PolyEq_erls,
    prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      \<^rule_thm>\<open>d4_sub_u1\<close> (* ax^4+bx^2+c=0 -> x=+-sqrt(ax^2+bx^+c) *)],
    program = Rule.Empty_Prog});
\<close>
rule_set_knowledge
  d0_polyeq_simplify = d0_polyeq_simplify and
  d1_polyeq_simplify = d1_polyeq_simplify and
  d2_polyeq_simplify = d2_polyeq_simplify and
  d2_polyeq_bdv_only_simplify = d2_polyeq_bdv_only_simplify and
  d2_polyeq_sq_only_simplify = d2_polyeq_sq_only_simplify and

  d2_polyeq_pqFormula_simplify = d2_polyeq_pqFormula_simplify and
  d2_polyeq_abcFormula_simplify = d2_polyeq_abcFormula_simplify and
  d3_polyeq_simplify = d3_polyeq_simplify and
  d4_polyeq_simplify = d4_polyeq_simplify

problem pbl_equ_univ_poly : "polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "~((e_e::bool) is_ratequation_in (v_v::real))"
	  "~((lhs e_e) is_rootTerm_in (v_v::real))"
	  "~((rhs e_e) is_rootTerm_in (v_v::real))"
  Find: "solutions v_v'i'"

(*--- d0 ---*)
problem pbl_equ_univ_poly_deg0 : "degree_0/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d0_polyeq_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a = 0) e_e"
    "(lhs e_e) is_poly_in v_v"
    "((lhs e_e) has_degree_in v_v ) = 0"
  Find: "solutions v_v'i'"

(*--- d1 ---*)
problem pbl_equ_univ_poly_deg1 : "degree_1/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d1_polyeq_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a = 0) e_e"
	  "(lhs e_e) is_poly_in v_v"
	  "((lhs e_e) has_degree_in v_v ) = 1"
  Find: "solutions v_v'i'"

(*--- d2 ---*)
problem pbl_equ_univ_poly_deg2 : "degree_2/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d2_polyeq_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a = 0) e_e"
    "(lhs e_e) is_poly_in v_v "
    "((lhs e_e) has_degree_in v_v ) = 2"
  Find: "solutions v_v'i'"

problem pbl_equ_univ_poly_deg2_sqonly : "sq_only/degree_2/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d2_polyeq_sqonly_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches ( ?a +    ?v_ \<up> 2 = 0) e_e |
     matches ( ?a + ?b*?v_ \<up> 2 = 0) e_e |
     matches (         ?v_ \<up> 2 = 0) e_e |
     matches (      ?b*?v_ \<up> 2 = 0) e_e"
    "Not (matches (?a +    ?v_ +    ?v_ \<up> 2 = 0) e_e) &
     Not (matches (?a + ?b*?v_ +    ?v_ \<up> 2 = 0) e_e) &
     Not (matches (?a +    ?v_ + ?c*?v_ \<up> 2 = 0) e_e) &
     Not (matches (?a + ?b*?v_ + ?c*?v_ \<up> 2 = 0) e_e) &
     Not (matches (        ?v_ +    ?v_ \<up> 2 = 0) e_e) &
     Not (matches (     ?b*?v_ +    ?v_ \<up> 2 = 0) e_e) &
     Not (matches (        ?v_ + ?c*?v_ \<up> 2 = 0) e_e) &
     Not (matches (     ?b*?v_ + ?c*?v_ \<up> 2 = 0) e_e)"
  Find: "solutions v_v'i'"

problem pbl_equ_univ_poly_deg2_bdvonly : "bdv_only/degree_2/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d2_polyeq_bdvonly_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a*?v_ +    ?v_ \<up> 2 = 0) e_e |
     matches (   ?v_ +    ?v_ \<up> 2 = 0) e_e |
     matches (   ?v_ + ?b*?v_ \<up> 2 = 0) e_e |
     matches (?a*?v_ + ?b*?v_ \<up> 2 = 0) e_e |
     matches (            ?v_ \<up> 2 = 0) e_e |
     matches (         ?b*?v_ \<up> 2 = 0) e_e "
  Find: "solutions v_v'i'"

problem pbl_equ_univ_poly_deg2_pq : "pqFormula/degree_2/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d2_polyeq_pq_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a + 1*?v_ \<up> 2 = 0) e_e |
     matches (?a +   ?v_ \<up> 2 = 0) e_e"
  Find: "solutions v_v'i'"

problem pbl_equ_univ_poly_deg2_abc : "abcFormula/degree_2/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d2_polyeq_abc_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a +    ?v_ \<up> 2 = 0) e_e |
     matches (?a + ?b*?v_ \<up> 2 = 0) e_e"
  Find: "solutions v_v'i'"

(*--- d3 ---*)
problem pbl_equ_univ_poly_deg3 : "degree_3/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/solve_d3_polyeq_equation"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a = 0) e_e"
    "(lhs e_e) is_poly_in v_v"
    "((lhs e_e) has_degree_in v_v) = 3"
  Find: "solutions v_v'i'"

(*--- d4 ---*)
problem pbl_equ_univ_poly_deg4 : "degree_4/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  (*Method: "PolyEq/solve_d4_polyeq_equation"*)
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a = 0) e_e"
    "(lhs e_e) is_poly_in v_v"
    "((lhs e_e) has_degree_in v_v) = 4"
  Find: "solutions v_v'i'"

(*--- normalise ---*)
problem pbl_equ_univ_poly_norm : "normalise/polynomial/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/normalise_poly"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "(Not((matches (?a = 0 ) e_e ))) |
     (Not(((lhs e_e) is_poly_in v_v)))"
  Find: "solutions v_v'i'"

(*-------------------------expanded-----------------------*)
problem "pbl_equ_univ_expand" : "expanded/univariate/equation" =
  \<open>PolyEq_prls\<close>
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where:
    "matches (?a = 0) e_e"
    "(lhs e_e) is_expanded_in v_v "
  Find: "solutions v_v'i'"

(*--- d2 ---*)
problem pbl_equ_univ_expand_deg2 : "degree_2/expanded/univariate/equation" =
  \<open>PolyEq_prls\<close>
  Method_Ref: "PolyEq/complete_square"
  CAS: "solve (e_e::bool, v_v)"
  Given: "equality e_e" "solveFor v_v"
  Where: "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

text \<open>"-------------------------methods-----------------------"\<close>

method met_polyeq : "PolyEq" =
  \<open>{rew_ord="tless_true",rls'=Atools_erls,calc = [], prog_rls = Rule_Set.empty, where_rls=Rule_Set.empty,
    errpats = [], rew_rls = norm_Rational}\<close>

partial_function (tailrec) normalize_poly_eq :: "bool \<Rightarrow> real \<Rightarrow> bool"
  where
"normalize_poly_eq e_e v_v = (
  let
    e_e = (
      (Try (Rewrite ''all_left'')) #>
      (Try (Repeat (Rewrite ''makex1_x''))) #>
      (Try (Repeat (Rewrite_Set ''expand_binoms''))) #>
      (Try (Repeat (Rewrite_Set_Inst [(''bdv'', v_v)] ''make_ratpoly_in''))) #>
      (Try (Repeat (Rewrite_Set ''polyeq_simplify''))) ) e_e
  in
    SubProblem (''PolyEq'', [''polynomial'', ''univariate'', ''equation''], [''no_met''])
      [BOOL e_e, REAL v_v])"

method met_polyeq_norm : "PolyEq/normalise_poly" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls, calc = [],
    errpats = [], rew_rls = norm_Rational}\<close>
  Program: normalize_poly_eq.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(Not((matches (?a = 0 ) e_e ))) | (Not(((lhs e_e) is_poly_in v_v)))"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ e_e v_v = (
  let
    e_e = (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d0_polyeq_simplify'')) e_e   
  in
    Or_to_List e_e)"

method met_polyeq_d0 : "PolyEq/solve_d0_polyeq_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 0"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_eq1 :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_eq1 e_e v_v = (
  let
    e_e = (
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d1_polyeq_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #> 
      (Try (Rewrite_Set ''norm_Rational_parenthesized'')) ) e_e;
    L_L = Or_to_List e_e
  in
    Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d1 : "PolyEq/solve_d1_polyeq_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_eq1.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v" "((lhs e_e) has_degree_in v_v) = 1"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ2 :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ2 e_e v_v = (
  let
    e_e = (
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d2_polyeq_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d1_polyeq_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set ''norm_Rational_parenthesized'')) ) e_e;
    L_L =  Or_to_List e_e
  in
    Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d22 : "PolyEq/solve_d2_polyeq_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ2.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ0 :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ0 e_e v_v = (
  let
     e_e = (
       (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d2_polyeq_bdv_only_simplify'')) #>
       (Try (Rewrite_Set ''polyeq_simplify'')) #>
       (Try (Rewrite_Set_Inst [(''bdv'',v_v::real)] ''d1_polyeq_simplify'')) #>
       (Try (Rewrite_Set ''polyeq_simplify'')) #>
       (Try (Rewrite_Set ''norm_Rational_parenthesized'')) ) e_e;
     L_L = Or_to_List e_e
  in
    Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d2_bdvonly : "PolyEq/solve_d2_polyeq_bdvonly_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ0.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ_sqrt :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ_sqrt e_e v_v = (
  let
    e_e = (
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d2_polyeq_sq_only_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set ''norm_Rational_parenthesized'')) ) e_e;
    L_L = Or_to_List e_e
  in
    Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d2_sqonly : "PolyEq/solve_d2_polyeq_sqonly_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ_sqrt.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ_pq :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ_pq e_e v_v = (
  let
    e_e = (
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d2_polyeq_pqFormula_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set ''norm_Rational_parenthesized'')) ) e_e;
    L_L = Or_to_List e_e
  in
    Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d2_pq : "PolyEq/solve_d2_polyeq_pq_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ_pq.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ_abc :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ_abc e_e v_v = (
  let
    e_e = (
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d2_polyeq_abcFormula_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set ''norm_Rational_parenthesized'')) ) e_e;
    L_L = Or_to_List e_e
  in Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d2_abc : "PolyEq/solve_d2_polyeq_abc_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls,prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ_abc.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

partial_function (tailrec) solve_poly_equ3 :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_poly_equ3 e_e v_v = (
  let
    e_e = (
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d3_polyeq_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''d2_polyeq_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set_Inst [(''bdv'',v_v)] ''d1_polyeq_simplify'')) #>
      (Try (Rewrite_Set ''polyeq_simplify'')) #>
      (Try (Rewrite_Set ''norm_Rational_parenthesized''))) e_e;
    L_L = Or_to_List e_e
  in
    Check_elementwise L_L {(v_v::real). Assumptions})"

method met_polyeq_d3 : "PolyEq/solve_d3_polyeq_equation" =
  \<open>{rew_ord="termlessI", rls'=PolyEq_erls, prog_rls=Rule_Set.empty, where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_poly_equ3.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "(lhs e_e) is_poly_in v_v " "((lhs e_e) has_degree_in v_v) = 3"
  Find: "solutions v_v'i'"

    (*.solves all expanded (ie. normalised) terms of degree 2.*)
    (*Oct.02 restriction: 'eval_true 0 =< discriminant' ony for integer values
      by 'PolyEq_erls'; restricted until Float.thy is implemented*)
partial_function (tailrec) solve_by_completing_square :: "bool \<Rightarrow> real \<Rightarrow> bool list"
  where
"solve_by_completing_square e_e v_v = (
  let e_e = (
    (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''cancel_leading_coeff'')) #>
    (Try (Rewrite_Set_Inst [(''bdv'', v_v)] ''complete_square'')) #>
    (Try (Rewrite ''square_explicit1'')) #>
    (Try (Rewrite ''square_explicit2'')) #>
    (Rewrite ''root_plus_minus'') #>
    (Try (Repeat (Rewrite_Inst [(''bdv'', v_v)] ''bdv_explicit1''))) #>
    (Try (Repeat (Rewrite_Inst [(''bdv'', v_v)] ''bdv_explicit2''))) #>
    (Try (Repeat (Rewrite_Inst [(''bdv'', v_v)] ''bdv_explicit3''))) #>
    (Try (Rewrite_Set ''calculate_RootRat'')) #>
    (Try (Repeat (Calculate ''SQRT'')))) e_e
  in
    Or_to_List e_e)"

method met_polyeq_complsq : "PolyEq/complete_square" =
  \<open>{rew_ord="termlessI",rls'=PolyEq_erls,prog_rls=Rule_Set.empty,where_rls=PolyEq_prls,
    calc = [("sqrt", (\<^const_name>\<open>sqrt\<close>, eval_sqrt "#sqrt_"))], errpats = [],
    rew_rls = norm_Rational}\<close>
  Program: solve_by_completing_square.simps
  Given: "equality e_e" "solveFor v_v"
  Where: "matches (?a = 0) e_e" "((lhs e_e) has_degree_in v_v) = 2"
  Find: "solutions v_v'i'"

ML\<open>

(* termorder hacked by MG, adapted later by WN *)
(**)local (*. for make_polynomial_in .*)

open Term;  (* for type order = EQUAL | LESS | GREATER *)

fun pr_ord EQUAL = "EQUAL"
  | pr_ord LESS  = "LESS"
  | pr_ord GREATER = "GREATER";

fun dest_hd' _ (Const (a, T)) = (((a, 0), T), 0)
  | dest_hd' x (t as Free (a, T)) =
    if x = t then ((("|||||||||||||", 0), T), 0)                        (*WN*)
    else (((a, 0), T), 1)
  | dest_hd' _ (Var v) = (v, 2)
  | dest_hd' _ (Bound i) = ((("", i), dummyT), 3)
  | dest_hd' _ (Abs (_, T, _)) = ((("", 0), T), 4)
  | dest_hd' _ _ = raise ERROR "dest_hd': uncovered case in fun.def.";

fun size_of_term' i pr x (t as Const (\<^const_name>\<open>realpow\<close>, _) $ 
      Free (var, _) $ Free (pot, _)) =
    (if pr then tracing (idt "#" i ^ "size_of_term' realpow: " ^ UnparseC.term @{context} t) else ();
    case x of                                                          (*WN*)
	    (Free (xstr, _)) => 
		    if xstr = var
        then (if pr then tracing (idt "#" i ^ "xstr = var --> " ^ string_of_int (1000 * (the (TermC.int_opt_of_string pot)))) else ();
          1000 * (the (TermC.int_opt_of_string pot)))
        else (if pr then tracing (idt "#" i ^ "x <> Free  --> " ^ "3") else (); 3)
	  | _ => raise ERROR ("size_of_term' called with subst = " ^ UnparseC.term @{context} x))
  | size_of_term' i pr x (t as Abs (_, _, body)) =
    (if pr then tracing (idt "#" i ^ "size_of_term' Abs: " ^ UnparseC.term @{context} t) else ();
    1 + size_of_term' (i + 1) pr x body)
  | size_of_term' i pr x (f $ t) =
    let
      val _ = if pr then tracing (idt "#" i ^ "size_of_term' $$$: " ^ UnparseC.term @{context} f ^ " $$$ " ^ UnparseC.term @{context} t) else ();
      val s1 = size_of_term' (i + 1) pr x f
      val s2 = size_of_term' (i + 1) pr x t
      val _ = if pr then tracing (idt "#" i ^ "size_of_term' $$$-->: " ^ string_of_int s1 ^ " + " ^ string_of_int s2 ^ " = " ^ string_of_int(s1 + s2)) else ();
    in (s1 + s2) end
  | size_of_term' i pr x t =
    (if pr then tracing (idt "#" i ^ "size_of_term' bot: " ^ UnparseC.term @{context} t) else ();
    case t of
      Free (subst, _) => 
       (case x of
   	     Free (xstr, _) =>
            if xstr = subst
            then (if pr then tracing (idt "#" i ^ "xstr = var --> " ^ "1000") else (); 1000)
            else (if pr then tracing (idt "#" i ^ "x <> Free  --> " ^ "1") else (); 1)
   	   | _ => raise ERROR ("size_of_term' called with subst = " ^ UnparseC.term @{context} x))
     | _ => (if pr then tracing (idt "#" i ^ "bot        --> " ^ "1") else (); 1));

fun term_ord' i pr x ctxt (Abs (_, T, t), Abs(_, U, u)) =       (* ~ term.ML *)
    let
      val _ = if pr then tracing (idt "#" i ^ "term_ord' Abs") else ();
      val ord =
        case term_ord' (i + 1) pr x ctxt (t, u) of EQUAL => Term_Ord.typ_ord (T, U) | ord => ord
      val _  = if pr then tracing (idt "#" i ^ "term_ord' Abs --> " ^ pr_ord ord) else ()
    in ord end
  | term_ord' i pr x ctxt (t, u) =
    let
      val _ = if pr then tracing (idt "#" i ^ "term_ord' bot (" ^ UnparseC.term ctxt t ^ 
        ", " ^ UnparseC.term ctxt u ^ ")") else ();
      val ord =
    	  case int_ord (size_of_term' (i + 1) pr x t, size_of_term' (i + 1) pr x u) of
    	    EQUAL =>
    	      let val (f, ts) = strip_comb t and (g, us) = strip_comb u 
            in
    	        (case hd_ord (i + 1) pr x ctxt (f, g) of 
    	           EQUAL => (terms_ord x (i + 1) pr ctxt) (ts, us) 
    	         | ord => ord)
    	      end
    	  | ord => ord
      val _  = if pr then tracing (idt "#" i ^ "term_ord' bot --> " ^ pr_ord ord) else ()
    in ord end
and hd_ord i pr x ctxt (f, g) =                                        (* ~ term.ML *)
    let
      val _ = if pr then tracing (idt "#" i ^ "hd_ord (" ^ UnparseC.term ctxt f ^ 
        ", " ^ UnparseC.term @{context} g ^ ")") else ();
      val ord = prod_ord
        (prod_ord Term_Ord.indexname_ord Term_Ord.typ_ord) int_ord
          (dest_hd' x f, dest_hd' x g)
      val _ = if pr then tracing (idt "#" i ^ "hd_ord --> " ^ pr_ord ord) else ();
    in ord end
and terms_ord x i pr ctxt (ts, us) = 
    let
      val _ = if pr then tracing (idt "#" i ^ "terms_ord (" ^ UnparseC.terms ctxt ts ^ 
        ", " ^ UnparseC.terms ctxt us ^ ")") else ();
      val ord = list_ord (term_ord' (i + 1) pr x ctxt) (ts, us);
      val _ = if pr then tracing (idt "#" i ^ "terms_ord --> " ^ pr_ord ord) else ();
    in ord end

(**)in(*local*)

fun ord_make_polynomial_in (pr:bool) ctxt subst (ts, us) =
  ((** )tracing ("*** subs variable is: " ^ Env.subst2str subst); ( **)
	case subst of
	  (_, x) :: _ =>
      term_ord' 1 pr x ctxt (TermC.numerals_to_Free ts, TermC.numerals_to_Free us) = LESS
	| _ => raise ERROR ("ord_make_polynomial_in called with subst = " ^ Env.subst2str subst))

end;(*local*)
\<close> ML \<open>
ord_make_polynomial_in
\<close> ML \<open>
\<close>
ML\<open>
val order_add_mult_in = prep_rls'(
  Rule_Def.Repeat{id = "order_add_mult_in", preconds = [], 
    rew_ord = ("ord_make_polynomial_in", ord_make_polynomial_in false),
    asm_rls = Rule_Set.empty,prog_rls = Rule_Set.Empty,
    calc = [], errpatts = [],
    rules = [
       \<^rule_thm>\<open>mult.commute\<close>, (* z * w = w * z *)
	     \<^rule_thm>\<open>real_mult_left_commute\<close>, (*z1.0 * (z2.0 * z3.0) = z2.0 * (z1.0 * z3.0)*)
	     \<^rule_thm>\<open>mult.assoc\<close>, (*z1.0 * z2.0 * z3.0 = z1.0 * (z2.0 * z3.0)*)
	     \<^rule_thm>\<open>add.commute\<close>,	 (*z + w = w + z*)
	     \<^rule_thm>\<open>add.left_commute\<close>, (*x + (y + z) = y + (x + z)*)
	     \<^rule_thm>\<open>add.assoc\<close>], (*z1.0 + z2.0 + z3.0 = z1.0 + (z2.0 + z3.0)*)
    program = Rule.Empty_Prog});

\<close>
ML\<open>
val collect_bdv = prep_rls'(
  Rule_Def.Repeat{id = "collect_bdv", preconds = [], 
    rew_ord = ("dummy_ord", Rewrite_Ord.function_empty),
    asm_rls = Rule_Set.empty,prog_rls = Rule_Set.Empty,
    calc = [], errpatts = [],
    rules = [\<^rule_thm>\<open>bdv_collect_1\<close>,
	     \<^rule_thm>\<open>bdv_collect_2\<close>,
	     \<^rule_thm>\<open>bdv_collect_3\<close>,
    
	     \<^rule_thm>\<open>bdv_collect_assoc1_1\<close>,
	     \<^rule_thm>\<open>bdv_collect_assoc1_2\<close>,
	     \<^rule_thm>\<open>bdv_collect_assoc1_3\<close>,
    
	     \<^rule_thm>\<open>bdv_collect_assoc2_1\<close>,
	     \<^rule_thm>\<open>bdv_collect_assoc2_2\<close>,
	     \<^rule_thm>\<open>bdv_collect_assoc2_3\<close>,
    
    
	     \<^rule_thm>\<open>bdv_n_collect_1\<close>,
	     \<^rule_thm>\<open>bdv_n_collect_2\<close>,
	     \<^rule_thm>\<open>bdv_n_collect_3\<close>,
    
	     \<^rule_thm>\<open>bdv_n_collect_assoc1_1\<close>,
	     \<^rule_thm>\<open>bdv_n_collect_assoc1_2\<close>,
	     \<^rule_thm>\<open>bdv_n_collect_assoc1_3\<close>,
    
	     \<^rule_thm>\<open>bdv_n_collect_assoc2_1\<close>,
	     \<^rule_thm>\<open>bdv_n_collect_assoc2_2\<close>,
	     \<^rule_thm>\<open>bdv_n_collect_assoc2_3\<close>],
    program = Rule.Empty_Prog});

\<close>
ML\<open>
(*.transforms an arbitrary term without roots to a polynomial [4] 
   according to knowledge/Poly.sml.*) 
val make_polynomial_in = prep_rls'(
  Rule_Set.Sequence {
    id = "make_polynomial_in", preconds = [], rew_ord = ("dummy_ord", Rewrite_Ord.function_empty),
    asm_rls = Atools_erls, prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      Rule.Rls_ expand_poly,
	    Rule.Rls_ order_add_mult_in,
	    Rule.Rls_ simplify_power,
	    Rule.Rls_ collect_numerals,
	    Rule.Rls_ reduce_012,
	    \<^rule_thm>\<open>realpow_oneI\<close>,
	    Rule.Rls_ discard_parentheses,
	    Rule.Rls_ collect_bdv],
    program = Rule.Empty_Prog});     

\<close>
ML\<open>
val separate_bdvs = Rule_Set.append_rules "separate_bdvs" collect_bdv [
  \<^rule_thm>\<open>separate_bdv\<close>, (*"?a * ?bdv / ?b = ?a / ?b * ?bdv"*)
	\<^rule_thm>\<open>separate_bdv_n\<close>,
	\<^rule_thm>\<open>separate_1_bdv\<close>, (*"?bdv / ?b = (1 / ?b) * ?bdv"*)
	\<^rule_thm>\<open>separate_1_bdv_n\<close>, (*"?bdv \<up> ?n / ?b = 1 / ?b * ?bdv \<up> ?n"*)
	\<^rule_thm>\<open>add_divide_distrib\<close> (*"(?x + ?y) / ?z = ?x / ?z + ?y / ?z"
	WN051031 DOES NOT BELONG TO HERE*)];
\<close>
ML\<open>
val make_ratpoly_in = prep_rls'(
  Rule_Set.Sequence {
    id = "make_ratpoly_in", preconds = []:term list, rew_ord = ("dummy_ord", Rewrite_Ord.function_empty),
    asm_rls = Atools_erls, prog_rls = Rule_Set.Empty, calc = [], errpatts = [],
    rules = [
      Rule.Rls_ norm_Rational,
	    Rule.Rls_ order_add_mult_in,
	    Rule.Rls_ discard_parentheses,
	    Rule.Rls_ separate_bdvs,
	    (* Rule.Rls_ rearrange_assoc, WN060916 why does cancel_p not work?*)
	    Rule.Rls_ cancel_p
	    (*\<^rule_eval>\<open>divide\<close> (eval_cancel "#divide_e") too weak!*)],
    program = Rule.Empty_Prog});      
\<close>
rule_set_knowledge
  order_add_mult_in = order_add_mult_in and
  collect_bdv = collect_bdv and
  make_polynomial_in = make_polynomial_in and
  make_ratpoly_in = make_ratpoly_in and
  separate_bdvs = separate_bdvs
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>
end






